unit Pcap;

interface
uses
  Windows,
  Packet32;

type
  TWinVersion = (Wv_win31,Wv_win95,     //Added by Lars Peter Christiansen.
                 wv_win98,wv_winNT,     //Eases the process of determing the
                 wv_win2000,wv_unknown);//platform and do proper instructions
                                        //I.e : Char vs. WideChar issue

function pcap_getwinversion(var verstr:string) : Twinversion;
function Pcap_getAdapternames(Delimiter:char):string;

implementation

function pcap_getwinversion(var verstr:string) : Twinversion;
var
    Info:OSVERSIONINFO;
begin
  info.dwOSVersionInfoSize := Sizeof(OSVERSIONINFO);
  result:=wv_unknown;

  if not GetVersionEx(Info) then exit;

 Case info.dwPlatformId of

       VER_PLATFORM_WIN32s : begin
                               result := wv_win31;
                               verStr := 'Win3.1';
                             end;

       VER_PLATFORM_WIN32_WINDOWS :
                             begin
                               result := wv_win95;
                               verstr := 'Win95';
                              end;
       VER_PLATFORM_WIN32_NT :
                             begin
                               if info.dwMajorVersion<5 then
                                 begin
                                   result := WV_winNT;
                                   verstr := 'WinNT';
                                 end
                               else
                                 begin
                                   result := WV_Win2000;
                                   verstr := 'Win2000';
                                 end;
                             end;
  end;
end;

function Pcap_GetAdapternames(Delimiter:char):string;
var NameList : Array [0..(1024*2)-1] of char;
    NameLength,
    i        :Longword;
    Ver      :Twinversion;
    s : string; // dummy;
begin
   NameLength := 1024;
   Ver := pcap_GetwinVersion(S);
   PacketGetAdapterNames(NameList,@NameLength);

   // WINDOWS 95 or 98  8bits per character
   if (Ver=wv_Win95) OR (Ver=wv_Win98) then
   begin
     for i:=0 to NameLength-1 do
     begin
       // modified
       if ((NameList[i]=#0) and (NameList[i+1]=#0))then
         break
       else
         if (NameList[i]=' ') or (NameList[i]=#0) then
           NameList[i]:=delimiter;
     end;
     result := NameList;
   end

   // WINDOWS NT OR 2000     16bits per character
   Else if (ver=wv_winNT) or (ver=wv_win2000) then
   begin
     for i:=0 to NameLength-1 do
     begin
       if (Pwidechar(@NameList)[i]=#0)and (PwideChar(@namelist)[i+1]<>#0) then
         PwideChar(@NameList)[i]:=WideChar(delimiter);
     end;
     result := WideCharToString(PWideChar(@NameList)) ;
   end;
end;


end.
